;------ Platinum Editon for Casio Algebra FX 2.0 - Player bullets
;
; Programmed by Patrick Davidson (pad@ocf.berkeley.edu)
;
; This software is in the public domain.  There is no warranty.

;------ fire player bullets

player_shoot:
        call    get_keystroke
        call    is_exit
        jne     .nq
        mov     byte [player_shield],-1
        ret

.nq:    cmp     ah,59
        jz      .select1
        cmp     ah,60
        jz      .select2
        cmp     ah,61
        jnz     .selected

        mov     al,[weapon_f3]
        or      al,al
        jz      .selected
        mov     byte [weapon_selected],2
        jmp     .selected

.select2:
        mov     al,[weapon_f2]
        or      al,al
        jz      .selected
        mov     byte [weapon_selected],1
        jmp     .selected

.select1:
        mov     byte [weapon_selected],0

.selected:
        call    check_shoot
        je      .ns

        mov     al,[just_shot]
        or      al,al
        jne     .q
        mov     byte [just_shot],1

        mov     al,[weapon_selected]
        cbw
        add     ax,ax
        mov     di,shoot_table
        add     di,ax
        jmp     [di]

.ns:    mov     byte [just_shot],0
.q:     ret

shoot_table:
        dw      shoot_1
        dw      shoot_2
        dw      shoot_3

shoot_2:
        mov     ah,4
        mov     si,player_bullet_2
        mov     bh,2
        mov     bl,[px]
        dec     bl
        call    shoot_ahead
        mov     bl,[px]
        add     bl,6
        jmp     shoot_ahead

shoot_3:
        call    shoot_1
        jz      shoot_ahead.q
        mov     byte [di],2
        mov     bh,3
        mov     bl,[px]
        dec     bl
        call    shoot_ahead
        add     bx,0x106
        jmp     shoot_ahead

shoot_1:
        mov     si,player_bullet
        mov     bl,[px]
        mov     bh,1
        add     bl,2
        mov     ah,3

shoot_ahead:
        call    find_player_bullet
        jne     .q

        mov     [di],bh
        mov     [di+b_x],bl
        mov     al,[si-1]
        mov     [di+b_w],al
        mov     al,[py]
        sub     al,2
        mov     [di+b_y],al
        mov     al,[si]
        mov     [di+b_h],al
        mov     byte [di+b_dmg],ah
        mov     [di+b_image],si
.q:     ret

find_player_bullet:
        mov     cx,b_count
        mov     di,b_array
        mov     dx,b_size
.loop:  mov     al,[di]
        or      al,al
        je      .q
        add     di,dx
        loop    .loop
.q:     ret

;------ process player's bullets

player_bullets:
        mov     cx,b_count
        mov     si,b_array
player_bullet_loop:
        push    cx
        push    si
        push    word bullet_done
        lodsb
        add     al,al
        cbw
        mov     di,bullet_table
        add     di,ax
        jmp     [di]
bullet_done:
        pop     si
        push    si
        lodsb
        or      al,al
        jz      .no_bullet
        mov     al,[si+b_y-1]
        mov     cl,[si+b_x-1]
        mov     si,[si+b_image-1]
        call    display_sprite_8
.no_bullet:
        pop     si
        pop     cx
        add     si,b_size
        loop    player_bullet_loop
return_pb:
        ret

bullet_table:
        dw      return_pb
        dw      bullet_1
        dw      bullet_2
        dw      bullet_left
        dw      bullet_right

bullet_right:
        mov     al,[si]
        inc     al
        mov     [si],al
        cmp     al,124
        jz      bullet_1.d
        jmp     bullet_1

bullet_left:
        dec     byte [si]
        jz      bullet_1.d
        jmp     bullet_1

bullet_2:
        dec     byte [si+b_y-1]
bullet_1:
        dec     byte [si+b_y-1]
        dec     byte [si+b_y-1]
        jl      .d
        ret
.d:     mov     byte [si-1],0
        ret

;------ detect player bullet / enemy hits

detect_enemy_hits:
        mov     di,b_array
        mov     cx,b_count
.bullet_loop:
        mov     al,[di]
        push    cx
        or      al,al
        jz      .no_bullet

        mov     bh,[di+b_x]
        mov     bl,[di+b_w]
        mov     dh,[di+b_y]
        mov     dl,[di+b_h]
        mov     si,e_array
        mov     cx,e_count
.enemy_loop:
        lodsb
        or      al,al
        jle     .no_enemy
        call    collision_check
        jnc     .no_enemy

        mov     byte [di],0
        mov     al,[di+b_dmg]
        sub     [si+e_dmg-1],al
        jnc     .no_bullet
        mov     byte [si-1],-1
        mov     byte [si+e_timer-1],3
        mov     word [si+e_image-1],explode_1
        jmp     .no_bullet

.no_enemy:
        add     si,e_size-1
        loop    .enemy_loop

.no_bullet:
        pop     cx
        add     di,b_size
        loop    .bullet_loop
        ret

;------ images

        db      3
player_bullet_2
        db      7
        db      01000000b
        db      11100000b
        db      11100000b
        db      11100000b
        db      11100000b
        db      11100000b
        db      11100000b
        
        db      4
player_bullet:
        db      6
        db      01100000b
        db      11110000b
        db      11110000b
        db      11110000b
        db      11110000b
        db      10010000b
