;------ Platinum Editon for Casio Algebra FX 2.0 - Enemies
;
; Programmed by Patrick Davidson (pad@ocf.berkeley.edu)
;
; This software is in the public domain.  There is no warranty.

;------ enemy types

        dw      enemy_exploding
enemy_table:
        dw      return_ss
        dw      enemy_1
        dw      boss_1
        dw      bounce

bounce: mov     al,[si+e_dx-1]
        or      al,[game_timer]
        and     al,1
        jz      .nox
        cmp     byte [si+e_dx-1],2
        jl      .left

        inc     byte [si+e_x-1]
        cmp     byte [si+e_x-1],101
        jnz     .nox
        push    si
        call    random_number
        pop     si
        and     al,1
        mov     [si+e_dx-1],al
        jmp     .nox

.left:  dec     byte [si+e_x-1]
        cmp     byte [si+e_x-1],17
        jnz     .nox
        push    si
        call    random_number
        pop     si
        and     al,1
        add     al,2
        mov     [si+e_dx-1],al

.nox:   mov     al,[si+e_dy-1]
        or      al,[game_timer]
        and     al,1
        jz      .noy
        cmp     byte [si+e_dy-1],2
        jl      .up

        inc     byte [si+e_y-1]
        cmp     byte [si+e_y-1],55
        jnz     .noy
        push    si
        call    random_number
        pop     si
        and     al,1
        mov     [si+e_dy-1],al
        jmp     .noy

.up:    dec     byte [si+e_y-1]
        cmp     byte [si+e_y-1],32
        jnz     .noy
        push    si
        call    random_number
        pop     si
        and     al,1
        add     al,2
        mov     [si+e_dy-1],al

.noy:   push    si
        call    random_number
        pop     si
        and     al,63
        jnz     .ns
        mov     bl,[si+e_y-1]
        mov     bh,[si+e_x-1]
        add     bx,0x305
        jmp     enemy_aim_shoot
.ns:    ret

boss_1: call    boss_move
        push    si
        call    random_number
        pop     si
        and     al,31
        jnz     .no_shoot
        mov     bl,[si+e_y-1]
        mov     bh,[si+e_x-1]
        add     bx,0x207
        call    enemy_aim_shoot
        mov     bl,[si+e_y-1]
        mov     bh,[si+e_x-1]
        add     bx,0xb07
        call    enemy_aim_shoot
.no_shoot:
        mov     al,[si+e_y-1]
        mov     cl,[si+e_x-1]
        add     cl,8
        mov     si,[si+e_image-1]
        add     si,11
        jmp     display_sprite_8

boss_move:
        mov     al,[si+e_phase-1]
        dec     al
        jz      .right
        dec     al
        jz      .left
        dec     byte [si+e_timer-1]
        jnz     .nn
        inc     byte [si+e_phase-1]
.nn:    jmp     enemy_1_move.go_down

.right: mov     al,[si+e_x-1]
        inc     al
        mov     [si+e_x-1],al
        cmp     al,81
        jnz     .q
        inc     byte [si+e_phase-1]
.q:     ret

.left:  mov     al,[si+e_x-1]
        dec     al
        mov     [si+e_x-1],al
        cmp     al,17
        jnz     .q
        dec     byte [si+e_phase-1]
        ret

enemy_1_move:
        dec     byte [si+e_timer-1]
        jge     .same_phase
        mov     byte [si+e_timer-1],16
        mov     al,[si+e_phase-1]
        inc     al
        and     al,3
        mov     [si+e_phase-1],al
.same_phase:
        mov     al,[si+e_phase-1]
        dec     al
        jz      .go_right
        dec     al
        jz      .go_up
        dec     al
        jz      .go_left
.go_down:
        mov     al,[game_timer]
        and     al,1
        jz      .q
        inc     byte [si+e_y-1]
.q:     ret
.go_right:
        inc     byte [si+e_x-1]
        ret
.go_up: mov     al,[game_timer]
        and     al,1
        jz      .q
        dec     byte [si+e_y-1]
        ret
.go_left:
        dec     byte [si+e_x-1]
        ret

enemy_exploding:
        dec     byte [si+e_timer-1]
        jz      .q
        mov     byte [si+e_timer-1],3
        mov     di,[si+e_image-1]
        add     di,7
        mov     [si+e_image-1],di
        cmp     di,explode_end
        jnz     .q
        mov     byte [si-1],0
        push    si
        call    random_number
        pop     si
        and     al,7
        jnz     .q
        call    find_enemy_bullet
        jnz     .q
        mov     al,-1
        stosb
        movsb
        mov     al,5
        stosb
        inc     si
        movsb
        mov     al,7
        stosb
        xor     al,al
        stosb
        mov     ax,bonus_image
        stosw
.q:     ret

find_enemy_bullet:
        mov     cx,f_count
        mov     di,f_array
        mov     dx,f_size
.loop:  mov     al,[di]
        or      al,al
        je      .q
        add     di,dx
        loop    .loop
.q:     ret

enemy_1:
        call    enemy_1_move
        push    si
        call    random_number
        pop     si
        and     al,127
        jnz     .q
        call    find_enemy_bullet
        jne     .q
        mov     al,1
        stosb
        mov     al,[si+e_x-1]
        add     al,2
        stosb
        mov     al,2
        stosb
        mov     al,[si+e_y-1]
        add     al,3
        stosb
        mov     al,2
        stosb
        xor     al,al
        stosb
        mov     ax,enemy_bullet_image
        stosw
.q:     ret

;------ process enemies

process_enemies:
        mov     byte [enemies_left],0
        mov     si,e_array
        mov     cx,e_count
enemy_loop:
        push    cx
        push    si
        lodsb
        cbw
        add     ax,ax
        mov     di,enemy_table
        add     di,ax
        push    word enemy_done
        jmp     [di]
enemy_done:
        pop     si
        push    si
        lodsb
        or      al,al
        jz      no_enemy_here
        inc     byte [enemies_left]
        mov     cl,[si+e_x-1]
        mov     al,[si+e_y-1]
        mov     si,[si+e_image-1]
        call    display_sprite_8
no_enemy_here:
        pop     si
        pop     cx
        add     si,e_size
        loop    enemy_loop

        mov     al,[enemies_left]
        or      al,al
        jz      load_new_level
        ret

load_new_level:
        mov     al,[level_number]
        inc     al
        mov     [level_number],al
        cbw
        add     ax,ax
        mov     di,level_table-2
        add     di,ax
        jmp     [di]

;------ images

        db      5
enemy_3_image:
        db      5
        db      10001000b
        db      11111000b
        db      10001000b
        db      01010000b
        db      00100000b

        db      6
enemy_1_image:
        db      6
        db      10000100b
        db      10000100b
        db      11111100b
        db      11111100b
        db      01111000b
        db      00110000b

        db      8
enemy_2_image:
        db      5
        db      10000001b
        db      11011011b
        db      11111111b
        db      11011011b
        db      10000001b

enemy_bounce_image:
        db      9
        db      00011000b
        db      00011000b
        db      00011000b
        db      00100100b
        db      01000010b
        db      10000001b
        db      10011001b
        db      10100101b
        db      11000011b

boss_image_left:
        db      10
        db      10000000b
        db      11000000b
        db      11111111b
        db      11000011b
        db      11000001b
        db      11000001b
        db      11000001b
        db      01100001b
        db      00111111b
        db      00011111b

boss_image_right:
        db      10
        db      00000001b
        db      00000011b
        db      11111111b
        db      11000011b
        db      10000011b
        db      10000011b
        db      10000011b
        db      10000110b
        db      11111100b
        db      11111000b

boss_image_left_2:
        db      10
        db      10000000b
        db      11000000b
        db      11111111b
        db      11101011b
        db      11010101b
        db      11101011b
        db      11010101b
        db      01101011b
        db      00111111b
        db      00011111b

boss_image_right_2:
        db      10
        db      00000001b
        db      00000011b
        db      11111111b
        db      11010111b
        db      10101011b
        db      11010111b
        db      10101011b
        db      11010110b
        db      11111100b
        db      11111000b

explode_1:
        db      6
        db      00000000b      
        db      00011100b      
        db      00111110b      
        db      01010110b      
        db      00111000b      
        db      00000000b      
        db      6     
        db      00110000b      
        db      01001110b      
        db      10111110b      
        db      01001111b      
        db      00111000b      
        db      00011010b      
        db      6     
        db      11110011b      
        db      01001110b      
        db      10110101b      
        db      01000101b      
        db      00111110b      
        db      11011010b      
        db      6     
        db      11110011b      
        db      01001110b      
        db      10110101b      
        db      01000101b      
        db      00111110b      
        db      11011010b      
        db      6     
        db      01000001b      
        db      00100110b      
        db      00010101b      
        db      01000100b      
        db      00010010b      
        db      10011010b      
        db      6     
        db      01000010b      
        db      00100000b      
        db      00000001b      
        db      01000100b      
        db      00100010b      
        db      10001010b      
        db      6     
        db      00001000b      
        db      11000010b      
        db      00000000b      
        db      00100000b      
        db      00000001b      
        db      00110000b      
        db      6     
        db      00000100b      
        db      00000000b      
        db      01000000b      
        db      00000000b      
        db      00000000b      
        db      00000001b      
explode_end:
