;------ Platinum Editon for Casio Algebra FX 2.0 - Levels
;
; Programmed by Patrick Davidson (pad@ocf.berkeley.edu)
;
; This software is in the public domain.  There is no warranty.

;------ install a row of enemies
;
; CX = # of ene`mies to install
; DI = position in e_array to begin
; AL = initial X coordinate
; AH = X coordinate step
; SI = image (height, width read from this)
; BL = initial Y coordinate
; BH = initial power
; DL = initial count value (phase defaults to 0)
; DH = enemy type

install_enemy_row:
        mov     [di+e_type],dh
        mov     [di+e_x],al
        add     al,ah
        mov     ch,[si-1]
        mov     [di+e_w],ch
        mov     [di+e_y],bl
        mov     ch,[si]
        mov     [di+e_h],ch
        xor     ch,ch
        mov     [di+e_dmg],bh
        mov     byte [di+e_phase],0
        mov     [di+e_timer],dl
        mov     [di+e_image],si
        add     di,e_size
        loop    install_enemy_row
        ret

;------ level initializations

level_table:
        dw      level_1
        dw      level_2
        dw      level_3
        dw      level_shop
        dw      level_4
        dw      level_5
        dw      level_bounce7
        dw      level_6
        dw      level_shop
        dw      level_7
        dw      level_8
        dw      level_bounce10
        dw      level_9
        dw      level_shop
        dw      level_restart

level_bounce10:
        mov     cx,10
        jmp     level_bounce

level_bounce7:
        mov     cx,7
level_bounce:
        mov     di,e_array
        mov     al,8
.loop:  mov     byte [di],3
        inc     di
        mov     [di+e_x],al
        stosb
        add     al,10
        push    cx
        mov     si,bounce_data
        mov     cx,e_size-2
        rep     movsb
        pop     cx
        loop    .loop
        ret

bounce_data:
        db      8
        db      20
        db      9
        db      15
        db      0
        db      0
        dw      enemy_bounce_image
        db      3
        db      3

level_restart:
        mov     byte [level_number],0
        jmp     load_new_level

level_6:
        mov     cx,7
        mov     di,e_array
        mov     ax,(12<<8)+15
        mov     bx,(5<<8)+14
        mov     si,enemy_2_image
        mov     dx,(1<<8)+80
        call    install_enemy_row
        mov     cx,7
        mov     al,15
        mov     bl,24
        call    install_enemy_row
        jmp     install_boss

level_9:
        mov     cx,10
        mov     di,e_array
        mov     ax,(8<<8)+15
        mov     bx,(9<<8)+14
        mov     si,enemy_3_image
        mov     dx,(1<<8)+80
        call    install_enemy_row
        mov     cx,9
        mov     al,20
        mov     bl,24
        call    install_enemy_row
install_boss2:
        mov     si,boss_data_2
        mov     cx,e_size
        rep     movsb
        ret

level_3:
        mov     cx,9
        mov     di,e_array
        mov     ax,(8<<8)+17
        mov     bx,(3<<8)+13
        mov     si,enemy_1_image
        mov     dx,(1<<8)+80
        call    install_enemy_row
        mov     al,17
        mov     cx,9
        mov     bl,24
        call    install_enemy_row
install_boss:
        mov     si,boss_data
        mov     cx,e_size
        rep     movsb
        ret

level_1:
        mov     cx,7
        mov     di,e_array
        mov     ax,(10<<8)+20
        mov     bx,(3<<8)
        mov     si,enemy_1_image
        mov     dx,(1<<8)+80
        call    install_enemy_row
        mov     cx,7
        mov     al,25
        mov     bl,11
        call    install_enemy_row
        mov     cx,7
        mov     al,20
        mov     bl,22
        jmp     install_enemy_row

level_2:
        mov     cx,9
        mov     di,e_array
        mov     ax,(8<<8)+17
        mov     bx,(3<<8)
        mov     si,enemy_1_image
        mov     dx,(1<<8)+80
        call    install_enemy_row
        mov     al,17
        mov     cx,9
        mov     bl,22
        call    install_enemy_row
        mov     cx,5
        mov     ax,(16<<8)+17
        mov     bl,11
        jmp     install_enemy_row

level_5:
        mov     cx,7
        mov     di,e_array
        mov     ax,(12<<8)+15
        mov     bx,(5<<8)
        mov     si,enemy_2_image
        mov     dx,(1<<8)+80
        call    install_enemy_row
        mov     cx,7
        mov     al,15
        mov     bl,11
        call    install_enemy_row
        mov     cx,7
        mov     al,15
        mov     bl,22
        jmp     install_enemy_row

level_4:
        mov     cx,7
        mov     di,e_array
        mov     ax,(12<<8)+15
        mov     bx,(5<<8)
        mov     si,enemy_2_image
        mov     dx,(1<<8)+80
        call    install_enemy_row
        mov     cx,7
        mov     al,15
        mov     bl,11
        call    install_enemy_row
        mov     cx,5
        mov     ax,(14<<8)+22
        mov     si,enemy_1_image
        mov     bx,(3<<8)+24
        jmp     install_enemy_row

level_7:
        mov     cx,7
        mov     di,e_array
        mov     ax,(11<<8)+17
        mov     bx,(9<<8)
        mov     si,enemy_3_image
        mov     dx,(1<<8)+80
        call    install_enemy_row
        mov     cx,7
        mov     al,17
        mov     bl,11
        call    install_enemy_row
        mov     cx,5
        mov     ax,(14<<8)+22
        mov     si,enemy_1_image
        mov     bx,(3<<8)+24
        jmp     install_enemy_row

level_8:
        mov     cx,7
        mov     di,e_array
        mov     ax,(12<<8)+16
        mov     bx,(9<<8)
        mov     si,enemy_3_image
        mov     dx,(1<<8)+80
        call    install_enemy_row
        mov     cx,7
        mov     al,17
        mov     bl,11
        call    install_enemy_row
        mov     cx,7
        mov     al,18
        mov     bl,22
        jmp     install_enemy_row
        
boss_data:
        db      2,16,16,1,10,80,0,64
        dw      boss_image_left

boss_data_2:
        db      2,16,16,1,10,110,0,64
        dw      boss_image_left_2
