;------ Platinum Editon 0.01 for Casio Algebra FX 2.0
;
; Calculator-specific routines
;
; Programmed by Patrick Davidson (pad@ocf.berkeley.edu)
;
; This software is in the public domain.  There is no warranty.

K_ESC   equ     1

;------ initialize and exit

SEGMENT code

..start:
        mov     ax,code
        mov     ds,ax
        mov     es,ax
        mov     ax,stack
        mov     ss,ax
        mov     sp,stack_end

        call    main_game

exit:   
        mov     ax,0x4c00
        int     0x21

text_mode:
        mov     ax,3
        int     0x10
        ret

;------ test keys

check_shoot:
        mov     ax,0000000100000000b
        out     0x13,ax
        mov     cx,20
.wait:  loop    .wait
        in      al,0x13
        and     al,0x20
        ret

check_left:
        mov     ax,0000001000000000b
        out     0x13,ax
        mov     cx,20
.wait:  loop    .wait
        in      al,0x13
        and     al,0x40
        ret

check_right:
        mov     ax,0000001000000000b
        out     0x13,ax
        mov     cx,20
.wait:  loop    .wait
        in      al,0x13
        and     al,8
        ret

check_up:
        mov     ax,0000001000000000b
        out     0x13,ax
        mov     cx,20
.wait:  loop    .wait
        in      al,0x13
        and     al,0x20
        ret

check_down:
        mov     ax,0000001000000000b
        out     0x13,ax
        mov     cx,20
.wait:  loop    .wait
        in      al,0x13
        and     al,0x10
        ret

is_exit:
        cmp     ah,1
        ret

;------ delay

delay:  mov     cx,[delay_time]
        inc     cx
.dl:    loop    .dl
graphics_mode:
        ret

;------ copy screen buffer to display

display_screen:
        push    es
        mov     ax,0x40
        mov     es,ax
        mov     ax,[es:0xe0]
        mov     es,ax
        mov     si,scrn+1023
        xor     di,di
        mov     bx,-17
        call    copy_plane
        pop     es
        ret

copy_plane:
        mov     cx,16
display_column:
        mov     dx,cx
        mov     cx,64
display_byte:
        lodsb
        stosb
        add     si,bx
        loop    display_byte
        mov     cx,dx
        add     si,1023
        loop    display_column
        ret

%include "platinum.asm"
