;------ Platinum Editon 0.01 for Casio Algebra FX 2.0
;
; Calculator-specific routines
;
; Programmed by Patrick Davidson (pad@ocf.berkeley.edu)
;
; This software is in the public domain.  There is no warranty.

;------ initialize and exit

SEGMENT code

..start:
        mov     ax,code
        mov     ds,ax
        mov     es,ax
        mov     ax,stack
        mov     ss,ax
        mov     sp,stack_end
       
        call    main_game

exit:   call    text_mode

        mov     ax,0x4c00
        int     0x21

text_mode:
        mov     ax,3
        int     0x10
        ret

graphics_mode:
        mov     ax,0x13
        int     0x10

        mov     dx,0x3c8
        xor     ax,ax
        mov     bl,0x15
l       out     dx,al
        inc     dx
        push    ax
        mul     bl           
        times 3 out dx,al
        pop     ax
        dec     dx
        inc     al
        cmp     al,4
        jnz     l
        ret

;------ delay

delay:   call   vwait

vwait:   mov      dx,      0x3c8
         mov      al,      0
         out      dx,      al
         inc      dx
         mov      al,      1
         out      dx,      al
         out      dx,      al
         out      dx,      al

         mov      dx,      0x3da
wv1      in       al,      dx
         and      al,      8
         jnz      wv1
wn1      in       al,      dx
         and      al,      8
         jz       wn1

         mov      dx,      0x3c8
         mov      al,      0
         out      dx,      al
         inc      dx
         out      dx,      al
         out      dx,      al
         out      dx,      al
         ret

;------ test keys

check_left:
        mov     ah,2
        int     0x16
        xor     al,1
        and     al,1
        ret

check_right:
        mov     ah,2
        int     0x16
        xor     al,2
        and     al,2
        ret

check_shoot:
        mov     ah,2
        int     0x16
        xor     al,4
        and     al,4
        ret

check_down:
check_up:
        xor     al,al
        ret

is_exit:
        cmp     al,27
        ret

;------ copy screen buffer to display

display_screen:
        push    es
        mov     ax,0xa000
        mov     es,ax
        mov     di,0
        mov     si,scrn

        mov     cx,64
display_row:
        push    cx
        mov     cx,16
display_byte:
        push    cx
        mov     cx,8
        mov     dh,[si]
        lodsb
        mov     ah,al
display_bit:
        mov     al,3
        add     ah,ah
        jnc     .d
        mov     al,1
.d      add     dh,dh
        jnc     .e
        dec     al
.e      stosb
        loop    display_bit
        pop     cx
        loop    display_byte
        pop     cx
        add     di,192
        loop    display_row
        pop     es
        ret

%include "platinum.asm"
